unit uUtil;

interface
  function CRC4(nachricht : word) : byte;
  
implementation

  function CRC4(nachricht : word) : byte;
  var
    poly,reg      : byte;
    i,stellenwert : integer;
  begin
    reg := nachricht shr 11;      // erste 5 Bits in reg
    nachricht := nachricht shl 4; // 0000 anhngen
    poly := 19;                   // 10011 binr
    stellenwert := 16384;         // 16384 = 2^14
    for i := 1 to 15 do
    begin
      if (reg and 16 > 0)         // Bit4 gesetzt?
      then
        reg := reg xor poly;
      reg := reg shl 1;           // 1 nach links schieben
      reg := reg and 31;          // hchste 3 Bit lschen, ntig ?
      if nachricht and stellenwert > 0 then reg := reg + 1;
      stellenwert := stellenwert div 2;
    end;
    if (reg and 16 > 0)           // Bit4 gesetzt?
    then
      reg := reg xor poly;
    result := reg;
  end;

end.
